// QuickSort code for CListViewerSort 1.00, Copyright (C) 2000-2005 Colin Munro

#define _BUILDINGLIB_
#include "ListViewer.h"
#include "ListViewerSort.h"

#define GETLAST(array,pos,length)		((pos>0)?array[pos-1].row:NULL)
#define GETNEXT(array,pos,length)		((pos<(length-1))?array[pos+1].row:NULL)

CListViewSorter::CListViewSorter()
{
}
CListViewSorter::~CListViewSorter()
{
}

void CListViewSorter::Sort(CColumn *column,CRow **linkedlist,bool bAscending)
{
	int count,pos,iFieldIdentifier;
	CRow *row,*temprow;
	CListViewSorter sorter;

	if((*linkedlist)==NULL) return; // Stop immediately, or Bad Things happen
	// Firsly, discover the number of elements our array shall contain
	for(row=(*linkedlist),count=0;row!=NULL;row=row->next,count++);
	iFieldIdentifier=column->iFieldIdentifier;
	
	// Now, allocate the array and fill it in
	array=new SORTDATA[count];
	for(row=(*linkedlist),pos=0;pos<count;pos++) {
		array[pos].row=row;
		array[pos].data=array[pos].row->FindField(iFieldIdentifier);
		// Recursive sort part
		if(array[pos].row->children!=NULL)
			sorter.Sort(column,&(array[pos].row->children),bAscending);
		// Remove from linked list
		temprow=row->next;
		row->last=NULL;
		row->next=NULL;
		row=temprow;
	}

	// Now, do the actual QuickSort
	QuickSort(column,bAscending,0,count-1);
	
	// Finally re-attach to the linked lists
	(*linkedlist)=array[0].row;
	for(pos=0;pos<count;pos++) {
		array[pos].row->last=GETLAST(array,pos,count);
		array[pos].row->next=GETNEXT(array,pos,count);
	}
	
	// And release memory
	delete[] array;
}

void CListViewSorter::QuickSort(CColumn *column,bool bAscending,int low,int high)
{
	int i,j;
	SORTDATA r;

	while(high>low) {
		i=low;
		j=high;
		r=array[low];
		while(i<j) {
			for(;SortCompare(column,bAscending,array[j],r)>0;j--);
			for(array[i]=array[j];(i<j)&&(SortCompare(column,bAscending,array[i],r)<=0);i++);
			array[j]=array[i];
		}
		array[i]=r;
		// Sort recursively
		if(i-low<high-i) {
			QuickSort(column,bAscending,low,i-1);
			low=i+1;
		} else {
			QuickSort(column,bAscending,i+1,high);
			high=i-1;
		}
	}
}

int CListViewSorter::SortCompare(CColumn *column,bool bAscending,SORTDATA a,SORTDATA b)
{
	CField *left=a.data,*right=b.data;
	int result;
	
	if(left==NULL) result=-1;
	else if(right==NULL) result=1;
	else result=column->CompareFields(a.data,b.data);
	return bAscending?result:(-result);
}
